#include "Comm.h"

Comm :: Comm() {

	connected = false;
	IP = new char[17];
	for (int i=0;i<17;i++) {
		IP[i] = ' ';
	}
}

Comm :: ~Comm() {}

void Comm :: openConn() {

	int e;

	san.sin_family = AF_INET;
	san.sin_port = htons(PORT);
	san.sin_addr.s_addr = inet_addr(IP);
	sanSize = sizeof(san);

	e = WSAStartup(0x0101,&ws);
	sckt = socket(AF_INET, SOCK_DGRAM,0);
	printf("\nError Report: %d\n", WSAGetLastError());

}

char* Comm :: getAddr() {

	return inet_ntoa(san.sin_addr);

}

void Comm :: openServerConn() {

	int e;
	int b;
							 //this acts as its own server and accepts any ip address
								//so we can direct connect to it
	san.sin_family = AF_INET;
	san.sin_port = htons(PORT);
	san.sin_addr.s_addr = htonl(INADDR_ANY);
	sanSize = sizeof(san);

	e = WSAStartup(0x0101,&ws);
	sckt = socket(AF_INET, SOCK_DGRAM,0);
	b = bind(sckt,(sockaddr *) &san,sanSize);
	printf("\nError Report: %d\n", WSAGetLastError());
}

void Comm :: setAddr(char *addr) {  //this will set an address if you want to reconnect to a different place

	for (int c=0;c<17;c++) {
		IP[c] = ' ';
	}

	int i=0;
	while (addr[i + 1] != '$') { //'$' terminates 
		IP[i] = addr[i+1];
		i++;
	}

}

void Comm :: setPort(int p) {
	PORT = p;
}

void Comm :: recvData(char *data) {

	int t;

	//printf("Receiving on socket: %d", sckt);
	t = recvfrom(sckt,data,MSG_LENGTH,0,(sockaddr *)&san,&sanSize);
	connected = true;


}

void Comm :: sendData(char *data) {

	int t;

	t = sendto(sckt,data,MSG_LENGTH,0,(sockaddr *)&san,sanSize);


}

void Comm :: setMaxMsgLength(int m) {

	MSG_LENGTH = m;
}

char *Comm :: getIP() {
	return IP;
}

void Comm :: setIP(char *ip) {

	sprintf(IP, "%s",ip);
}

void Comm :: closeConn() {

	shutdown(sckt, 1); 
	char *data;
	data = new char[MSG_LENGTH];
	closesocket(sckt);
	connected = false;
	sckt = NULL;
}