#ifndef PROTOCOL_H
#define PROTOCOL_H

#include <stdio.h>

const char P_ACCEPT = 'A';
const char P_CLOSE = 'C';
const char P_MESSAGE = 'M';
const char P_SHUTDOWN = 'S';
const char P_REBOOT = 'R';
const char P_GETWINDOW = 'G';
const char P_DELETE = 'K';
const char P_CAPTION = '&';
const char P_SPACE = '.';
const char P_SETIP = 'I';
const char P_RECEIVED = 'R';
const char P_WINDOW = 'W';
const char P_LOADBMP = 'P';
const char P_SAVEIP = 'B';
const char P_GETIP = 'X';

const int HAL_SERVER = 2501;//2501
const int HAL_US = 2500;//2500
const int US_SERVER = 2502;
const int THIRDPARTY = 2503;

const int MAX_LENGTH = 100;

char* encode(char cmd, char *str) {

	char msg[MAX_LENGTH] = " ";
//	for (int i=0;i<MAX_LENGTH;i++) {
//		msg[i] = ' ';
//	}
	sprintf(msg, "%c%s",cmd,str);//%s", cmd,str);
	return msg;

}

#endif