#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <stdio.h>

#include "serverComm.h"
#include "Protocol.h"

serverComm *hal = new serverComm();
serverComm *us = new serverComm();

bool SEND_TO_CLIENT = false;

//2 seperate threads
//this one waits till hal is connected
//once it is, it waits for a connection from us
//then when it has it it sends us hal's ip address
//and then waits to hear an 'R' - received
//and it closes connection with us - and waits for hal to be connected again
//to start the process over

DWORD WINAPI Receive_Thread(LPVOID data) {

	char msg[MAX_LENGTH] = " ";
	for (int i=0;i<MAX_LENGTH;i++) {
		msg[i] = ' ';
	}

	while (1) {
	
		us->openServerConn();
		printf("\nWaiting for connection from sender2...");
		us->recvData(msg);
		if (msg[0] == P_SAVEIP) {
			us->sendData(msg);
			printf("\nReceived, connection stored from sender2...");
			us->saveIP();
			SEND_TO_CLIENT = true;
		}
		else if (msg[0] == P_ACCEPT) {
			printf("\nReceived connection from sender2...");
			//while (hal->addrCleared()) {Sleep(100);}
			//	us->openConn();
			//	printf("\nWaiting for connection from sender2...");
			//	us->recvData(msg);
			sprintf(msg, "%c%s$", P_SETIP, hal->getSavedIP());
			printf("\nsending %s", msg);
			while (msg[0] != P_RECEIVED) {
				us->sendData(msg);  //sends a for address + address
				us->recvData(msg);
			}
			hal->clearAddr();
		}
		us->closeConn();
	}

	return ((DWORD)data);
}

//this one opens a connection to hal
//once it is received it closes and sends a 'C' to 
//hal to tell hal to close
//then it waits till we are connected
//before starting over
DWORD WINAPI Receive_Thread2(LPVOID data) {

	char msg[MAX_LENGTH] = " ";
	char msgSend[MAX_LENGTH] = " ";
	for (int i=0;i<MAX_LENGTH;i++) {
		msg[i] = ' ';
		msgSend[i] = ' ';
	}

	while (1) {
	
		hal->openServerConn();
		printf("\nWaiting for connection from help...");
		hal->recvData(msg);
		hal->saveIP();
		printf("\nReceived connection from %s", hal->getAddr());
		if (SEND_TO_CLIENT) {
			printf("\nTelling proxy client to connect with client B at %s", us->getSavedIP());
			sprintf(msgSend, "%c%s$" ,P_SETIP, us->getSavedIP());
			SEND_TO_CLIENT = false;
		}
		else {
			sprintf(msgSend,encode(P_CLOSE," "));
		}
		hal->sendData(msgSend);
			
		printf("\nClosing Connection...");
		hal->closeConn();
		//while (!hal->addrCleared()) {}

	}

	return ((DWORD)data);
}

void main() {

	static HANDLE thread_handle = NULL;
	static HANDLE thread_handle2 = NULL;
	unsigned long thread_id;
	unsigned long thread_id2;

	hal->setPort(HAL_SERVER);
	us->setPort(US_SERVER);
	
	hal->setMaxMsgLength(MAX_LENGTH);
	us->setMaxMsgLength(MAX_LENGTH);

	thread_handle = CreateThread(NULL,0,Receive_Thread,(LPVOID)0,0,&thread_id);
	thread_handle2 = CreateThread(NULL,0,Receive_Thread2,(LPVOID)0,0,&thread_id2);

	while (1) {};




}

